module GetImages where
import ImperativeState
import UrlAnalyse
import qualified Data.ByteString as BStr
import Network.URL as URL
import qualified Data.ByteString.UTF8 as UTF8Str
import Data.List.Split (splitOn)
import Control.Monad
import Data.Maybe
import Control.Monad.State
import Data.List
modpath2 :: String -> URL -> URL
modpath2 s u
  = u{url_path =
        if p /= [] then p ++ "/File:" ++ s else
          "/File:" ++ s}
  where pp = (url_path u)
        p= case reverse pp of 
             ('/':xs)->(reverse xs)
             xs->(reverse xs)


conv::String->String
conv s= if take 5 s == "http:" then s else if take 6 s == "https:" then "http:"++(drop 6 s) else "http:"++s


getImageUrl2:: String->Maybe String
getImageUrl2 s= (getImageUrl "fullImageLink" s) `mplus` (getImageUrl "fullMedia" s)

getImageUrl3:: String->Maybe String
getImageUrl3 s= return s


getImageUrl::String->String->Maybe String
getImageUrl fi ss =if isInfixOf fil s 
                   then 
                     case splitOn fil s of 
                       (_:y:_)-> case splitOn theHref y of
                                    (_:yy:_)-> case splitOn q yy of
                                                    (z:_)->Just (conv . UTF8Str.toString $ (BStr.pack z))
                                                    _ -> Nothing
                                    _ -> Nothing 
                       _ -> Nothing  
                   else Nothing
  where 
    s = BStr.unpack (UTF8Str.fromString ss)
    fil= BStr.unpack (UTF8Str.fromString fi)
    theHref= BStr.unpack (UTF8Str.fromString "href=\"")
    q= BStr.unpack (UTF8Str.fromString "\"")
  

getImagePage:: WikiUrl->String-> IO (Maybe ([String],BStr.ByteString))
getImagePage u ss=do l <- (mapM (geturl . unify . exportURL . modpath2 ss) (parses u)):: IO [String]
                     let xx=(map (getImageUrl2) l)::[Maybe String]
                     let gg=(zip (parses u) xx)::[(URL,Maybe String)]
                     let yy=(map go gg)::[[(URL,String)]]
                     let zz=(listToMaybe (concat yy))::Maybe (URL,String)
                     case zz of
                      Just (_,x) -> do img <- (geturl2 x)::(IO BStr.ByteString)
                                       return (Just (map (unify . exportURL . (modpath2 ss)) (parses u),img))
                      _ -> return Nothing
  where
    go::(URL,Maybe String)->[(URL,String)] 
    go (uu,Just x)= [(uu,x)] 
    go _ = []

doImage:: WikiUrl->String-> IO [Maybe (String,BStr.ByteString,[String])]
doImage theWikiUrl img = 
                      do p<-getImagePage theWikiUrl theName
                         case p of
                           Just (u,pp) -> return [Just (theName,pp,u)]
                           _ -> return [Nothing]
  where
    theName= case dropWhile (/=':') (takeWhile (/= '|') img) of
            (_:xs)->xs
            _-> []

            

getImages::[String]->WikiUrl->ImperativeMonad [Maybe (String,BStr.ByteString,[String])]
getImages images theWikiUrl = do l<-liftIO ((mapM (doImage theWikiUrl) images)) 
                                 return (concat l)
